#!/usr/bin/python

import iml3
import urllib
import cgi
import string
import ipcheck
from mod_python import apache

def __postsplit(str):
	tmp = string.split(str, "\r\n")
	for i in tmp:
		i0 = string.strip(i)
		if i0 != "": yield i0
def postsplit(str): 
	return list(__postsplit(str))

def handler(req, xml):
	if not ipcheck.check(req.get_remote_host(apache.REMOTE_NOLOOKUP)):
		raise RuntimeError("Используйте локальный адрес для редактирования")
	post = req.read()
	if not post:
		raise RuntimeError("Bad request")
	args = cgi.parse_qs(post, keep_blank_values = True, strict_parsing = True)

	if not args.has_key("dn"):
		raise RuntimeError("Bad request")
	dn = urllib.unquote(args["dn"][0])
	iml = iml3.IMLDB()
	film = iml.query(dn)
	
	xml.push("iml:list")

	iml = iml3.IMLDB()
	film = iml.query(dn)

	if not film:
		xml.data("<ssx:line>Film not found</ssx:line>\n")
		xml.pop("iml:list")
		return
		
	if args.has_key("film-gn"):
		film.gn = postsplit(args["film-gn"][0])

	if args.has_key("film-actor"):
		film.actors = postsplit(args["film-actor"][0])
	if args.has_key("film-director"):
		film.director = args["film-director"][0]
	if args.has_key("film-year"):
		film.year = args["film-year"][0]
	if args.has_key("film-genre"):
		film.genre = postsplit(args["film-genre"][0])
	if args.has_key("film-country"):
		film.country = postsplit(args["film-country"][0])

	iml.bind_rw()
	iml.modify_obj(film)

	film = iml.query(dn)
	xml.data(film.xml(mode = "long"))
	xml.data("<a href='helper.py?type=z80&amp;dn=%s'>helper</a>" % film.dn)
	xml.data("<ssx:title>iml3: %s</ssx:title>\n" % film.cn)
